SystemOrganization addCategory: #'Seaside-Tests-REST-Core'!

TestCase subclass: #WAAcceptsMatchTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-REST-Core'!

!WAAcceptsMatchTest methodsFor: 'tests' stamp: 'pmm 8/21/2011 15:05'!
testAcceptsConflict
	| pathElement routeXml routeJson acceptTextJS acceptAppJson acceptAll accepts routeContainer matchedRoute |
	pathElement := 'dontcare'.

	routeXml := WAComplexRoute
		method: 'GET'
		selector: #dontCare
		url: (WAUrl absolute: pathElement)
		arguments: #()
		produces: (WAFullMimeTypeMatch main: 'text' sub: 'xml')
		consumes: WAWildcardMimeTypeMatch new.
		
	routeJson := WAComplexRoute
		method: 'GET'
		selector: #dontCare
		url: (WAUrl absolute: pathElement)
		arguments: #()
		produces: (WAFullMimeTypeMatch main: 'application' sub: 'json')
		consumes: WAWildcardMimeTypeMatch new.
	
	acceptTextJS := WAAccept value: (WAMimeType main: 'text' sub: 'xml') quality: 0.5.
	acceptAppJson := WAAccept value: WAMimeType applicationJson quality: 0.5.
	acceptAll := WAAccept value: (WAMimeType main: '*' sub: '*') quality: 0.01.

	"this will sort:  acceptTextJS, acceptAppJson, acceptAll"	
	accepts := Array with: acceptAll with: acceptAppJson with: acceptTextJS.
	routeContainer := WARouteContainer routes: (Array with: routeXml with: routeJson).
	
	matchedRoute := routeContainer
		routeForElements: (Array with: pathElement)
		parameters: WARequestFields new
		contentType: nil
		accept: accepts
		ifAbsent: [ nil ].
	
	self assert: matchedRoute isNil
	
	
	
	
	
	
	
	
! !

!WAAcceptsMatchTest methodsFor: 'tests' stamp: 'pmm 8/21/2011 11:50'!
testAcceptsMatch
	| pathElement routeXml routeJson acceptTextJS acceptAppJson acceptAll accepts routeContainer matchedRoute |
	pathElement := 'dontcare'.

	routeXml := WAComplexRoute
		method: 'GET'
		selector: #dontCare
		url: (WAUrl absolute: pathElement)
		arguments: #()
		produces: (WASubMimeTypeMatch sub: 'xml')
		consumes: WAWildcardMimeTypeMatch new.
		
	routeJson := WAComplexRoute
		method: 'GET'
		selector: #dontCare
		url: (WAUrl absolute: pathElement)
		arguments: #()
		produces: (WAFullMimeTypeMatch main: 'application' sub: 'json')
		consumes: WAWildcardMimeTypeMatch new.
	
	acceptTextJS := WAAccept value: WAMimeType textJavascript quality: 1.0.
	acceptAppJson := WAAccept value: WAMimeType applicationJson quality: 1.0.
	acceptAll := WAAccept value: (WAMimeType main: '*' sub: '*') quality: 0.01.

	"this will sort:  acceptTextJS, acceptAppJson, acceptAll"	
	accepts := Array with: acceptAll with: acceptAppJson with: acceptTextJS.
	routeContainer := WARouteContainer routes: (Array with: routeXml with: routeJson).
	
	matchedRoute := routeContainer
		routeForElements: (Array with: pathElement)
		parameters: WARequestFields new
		contentType: nil
		accept: accepts
		ifAbsent: [ nil ].
	
	self assert: matchedRoute = routeJson
	
	
	
	
	
	
	
	
! !

!WAAcceptsMatchTest methodsFor: 'tests' stamp: 'pmm 8/21/2011 15:01'!
testAcceptsQuality
	| pathElement routeXml routeJson acceptTextJS acceptAppJson acceptAll accepts routeContainer matchedRoute |
	pathElement := 'dontcare'.

	routeXml := WAComplexRoute
		method: 'GET'
		selector: #dontCare
		url: (WAUrl absolute: pathElement)
		arguments: #()
		produces: (WASubMimeTypeMatch sub: 'xml')
		consumes: WAWildcardMimeTypeMatch new.
		
	routeJson := WAComplexRoute
		method: 'GET'
		selector: #dontCare
		url: (WAUrl absolute: pathElement)
		arguments: #()
		produces: (WAFullMimeTypeMatch main: 'application' sub: 'json')
		consumes: WAWildcardMimeTypeMatch new.
	
	acceptTextJS := WAAccept value: (WAMimeType main: 'text' sub: 'xml') quality: 1.0.
	acceptAppJson := WAAccept value: WAMimeType applicationJson quality: 0.5.
	acceptAll := WAAccept value: (WAMimeType main: '*' sub: '*') quality: 0.01.

	"this will sort:  acceptTextJS, acceptAppJson, acceptAll"	
	accepts := Array with: acceptAll with: acceptAppJson with: acceptTextJS.
	routeContainer := WARouteContainer routes: (Array with: routeXml with: routeJson).
	
	matchedRoute := routeContainer
		routeForElements: (Array with: pathElement)
		parameters: WARequestFields new
		contentType: nil
		accept: accepts
		ifAbsent: [ nil ].
	
	self assert: matchedRoute = routeXml
	
	
	
	
	
	
	
	
! !

TestCase subclass: #WAByMethodRoutesTest
	instanceVariableNames: 'routes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-REST-Core'!

!WAByMethodRoutesTest methodsFor: 'private' stamp: 'pmm 9/9/2009 19:23'!
assertMethod: aMethodString selector: aSymbol path: aFirstCollectionOfStrings arguments: aSecondCollectionOfStrings
	self
		assertMethod: aMethodString
		selector: aSymbol
		path: aFirstCollectionOfStrings
		parameters: Dictionary new
		arguments: aSecondCollectionOfStrings! !

!WAByMethodRoutesTest methodsFor: 'private' stamp: 'pmm 2/18/2012 14:07'!
assertMethod: aMethodString selector: aSymbol path: aFirstCollectionOfStrings parameters: aDictionary arguments: aSecondCollectionOfStrings
	| result stub requestUrl request context |
	requestUrl := WAUrl new
		addAllToPath: aFirstCollectionOfStrings;
		queryFields: aDictionary;
		yourself.
	request := WARequest
		method: aMethodString
		uri: requestUrl.
	context := WARequestContext request: request response: WAResponse new.
	result := routes routeForContext: context consume: true ifAbsent: [ self assert: false ].
	stub := WAByMethodRoutesStub new.
	result sendMessageTo: stub.
	self assert: stub selector = aSymbol.
	self assert: stub arguments = aSecondCollectionOfStrings.
	self assert: context consumer atEnd! !

!WAByMethodRoutesTest methodsFor: 'private' stamp: 'lr 7/26/2011 09:40'!
routes
	^ OrderedCollection new
		"Meta"
		add: (WARoute get: #getInfo);
		add: (WARoute get: '/_all_dbs' selector: #getAllDatabases);
		add: (WARoute get: '/_config' selector: #getConfig);
		add: (WARoute get: '/_stats' selector: #getStats);
		add: (WARoute get: '/_uuids?count={1}' selector: #getUuids:);
		add: (WARoute post: '/_replicate' selector: #replicate);
		
		"Database"
		add: (WARoute post: '/{1}/_compact' selector: #compactDatabase:);
		add: (WARoute put: #createDatabase:);
		add: (WARoute delete: #deleteDatabase:);
		add: (WARoute get: #getDatabase:);
		
		"Documents"
		add: (WARoute get: '/{1}/_all_docs' selector: #getAllDocuments:);
		add: (WARoute get: '/{2}/{1}' selector: #getDocument:ofDatabase:);
		add: (WARoute post: #createNewDocumentInDatabase:);
		add: (WARoute put: '/{2}/{1}' selector: #createOrUpdateDocument:inDatabase:);
		add: (WARoute delete: '/{2}/{1}' selector: #deleteDocument:inDatabase:);
		add: (WARoute post: '/{1}/_bulk_docs' selector: #createBulkDocumentsInDatabase:);
		add: (WARoute post: '/{1}/_temp_view' selector: #queryDatabase:);
		add: (WARoute get: '/{3}/_design/{2}/_view/{1}' selector: #getView:inDesign:inDatabase:);
		yourself! !

!WAByMethodRoutesTest methodsFor: 'running' stamp: 'lr 7/26/2011 09:41'!
setUp
	super setUp.
	routes := WAByMethodRoutes routes: self routes! !

!WAByMethodRoutesTest methodsFor: 'tests' stamp: 'JohanBrichau 1/4/2014 17:40'!
testArgumentNamesOf
	self assert: (GRPlatform current argumentNamesOf: (WAByMethodRoutesStub compiledMethodAt: #deleteDocument:inDatabase:)) asSet = #(aFirstString aSecondString) asSet! !

!WAByMethodRoutesTest methodsFor: 'tests' stamp: 'pmm 9/9/2009 19:17'!
testCompactDatabase
	self
		assertMethod: 'POST'
		selector: #compactDatabase:
		path: #('credit_cards' '_compact')
		arguments: #('credit_cards')! !

!WAByMethodRoutesTest methodsFor: 'tests' stamp: 'pmm 9/9/2009 19:21'!
testCreateBulkDocumentsInDatabase
	self
		assertMethod: 'POST'
		selector: #createBulkDocumentsInDatabase:
		path: #('credit_cards' '_bulk_docs')
		arguments: #('credit_cards')! !

!WAByMethodRoutesTest methodsFor: 'tests' stamp: 'pmm 9/9/2009 19:17'!
testCreateDatabase
	self
		assertMethod: 'PUT'
		selector: #createDatabase:
		path: #('credit_cards')
		arguments: #('credit_cards')! !

!WAByMethodRoutesTest methodsFor: 'tests' stamp: 'pmm 9/9/2009 19:19'!
testCreateNewDocumentInDatabase
	self
		assertMethod: 'POST'
		selector: #createNewDocumentInDatabase:
		path: #('credit_cards')
		arguments: #('credit_cards')! !

!WAByMethodRoutesTest methodsFor: 'tests' stamp: 'pmm 9/9/2009 19:20'!
testCreateOrUpdateDocumentinDatabase
	self
		assertMethod: 'PUT'
		selector: #createOrUpdateDocument:inDatabase:
		path: #('credit_cards' '1111-2222-3333-4444')
		arguments: #('1111-2222-3333-4444' 'credit_cards')! !

!WAByMethodRoutesTest methodsFor: 'tests' stamp: 'pmm 9/9/2009 19:17'!
testDeleteDatabase
	self
		assertMethod: 'DELETE'
		selector: #deleteDatabase:
		path: #('credit_cards')
		arguments: #('credit_cards')! !

!WAByMethodRoutesTest methodsFor: 'tests' stamp: 'pmm 9/9/2009 19:20'!
testDeleteDocumentInDatabase
	self
		assertMethod: 'DELETE'
		selector: #deleteDocument:inDatabase:
		path: #('credit_cards' '1111-2222-3333-4444')
		arguments: #('1111-2222-3333-4444' 'credit_cards')! !

!WAByMethodRoutesTest methodsFor: 'tests' stamp: 'pmm 9/9/2009 19:10'!
testGetAllDatabases
	self
		assertMethod: 'GET'
		selector: #getAllDatabases
		path: #('_all_dbs')
		arguments: #()! !

!WAByMethodRoutesTest methodsFor: 'tests' stamp: 'pmm 9/9/2009 19:11'!
testGetConfig
	self
		assertMethod: 'GET'
		selector: #getConfig
		path: #('_config')
		arguments: #()! !

!WAByMethodRoutesTest methodsFor: 'tests' stamp: 'pmm 9/9/2009 19:13'!
testGetDatabase
	self
		assertMethod: 'GET'
		selector: #getDatabase:
		path: #('credit_cards')
		arguments: #('credit_cards')! !

!WAByMethodRoutesTest methodsFor: 'tests' stamp: 'pmm 9/9/2009 19:16'!
testGetDocumentOfDatabase
	self
		assertMethod: 'GET'
		selector: #getDocument:ofDatabase:
		path: #('credit_cards' '1111-2222-3333-4444')
		arguments: #('1111-2222-3333-4444' 'credit_cards')! !

!WAByMethodRoutesTest methodsFor: 'tests' stamp: 'pmm 9/9/2009 19:10'!
testGetInfo
	self
		assertMethod: 'GET'
		selector: #getInfo
		path: #()
		arguments: #()! !

!WAByMethodRoutesTest methodsFor: 'tests' stamp: 'pmm 9/9/2009 19:11'!
testGetStats
	self
		assertMethod: 'GET'
		selector: #getStats
		path: #('_stats')
		arguments: #()! !

!WAByMethodRoutesTest methodsFor: 'tests' stamp: 'pmm 9/9/2009 19:25'!
testGetUuids
	self
		assertMethod: 'GET'
		selector: #getUuids:
		path: #('_uuids')
		parameters: (Dictionary new
			at: 'count' put: '100';
			yourself)
		arguments: #('100')! !

!WAByMethodRoutesTest methodsFor: 'tests' stamp: 'pmm 9/9/2009 19:23'!
testGetViewInDesignInDatabase
	self
		assertMethod: 'GET'
		selector: #getView:inDesign:inDatabase:
		path: #('credit_cards' '_design' 'fraud' '_view' 'recent')
		arguments: #('recent' 'fraud' 'credit_cards')! !

!WAByMethodRoutesTest methodsFor: 'tests' stamp: 'pmm 2/18/2012 14:08'!
testPathUnconsumedWhenNotFound
	| requestUrl request context notFound |
	requestUrl := WAUrl new
		addAllToPath: #('I' 'can' 'not' 'be' 'found');
		yourself.
	request := WARequest
		method: 'GET'
		uri: requestUrl.
	context := WARequestContext request: request response: WAResponse new.
	notFound := false.
	routes routeForContext: context consume: true ifAbsent: [ notFound := true ].
	self assert: notFound.
	self deny: context consumer atEnd.
	self assert: context consumer upToEnd = #('I' 'can' 'not' 'be' 'found') asOrderedCollection! !

!WAByMethodRoutesTest methodsFor: 'tests' stamp: 'pmm 9/9/2009 19:21'!
testQueryDatabase
	self
		assertMethod: 'POST'
		selector: #queryDatabase:
		path: #('credit_cards' '_temp_view')
		arguments: #('credit_cards')! !

!WAByMethodRoutesTest methodsFor: 'tests' stamp: 'pmm 9/9/2009 19:16'!
testReplicate
	self
		assertMethod: 'POST'
		selector: #replicate
		path: #('_replicate')
		arguments: #()! !

TestCase subclass: #WAComplexRouteTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-REST-Core'!

!WAComplexRouteTest methodsFor: 'tests' stamp: 'lr 7/26/2011 14:05'!
testComplexMatching
	| route arguments |
	route := WAComplexRoute
		method: 'GET'
		selector: #zork
		pattern: '/{first}/prefix{second}/{third}postfix/[methods.mcz|classes.mcz]'
		arguments: #('first' 'second' 'third')
		produces: nil
		consumes: nil.
	self assert: (route matchesPath: #('first' 'prefixO' 'zzpostfix' 'methods.mcz')).
	arguments := Array new: 3.
	route
		mapArgumentsWithElements: #('first' 'prefixO' 'zzpostfix' 'methods.mcz')
		parameters: Dictionary new
		into: arguments.
	self assert: arguments = #('first' 'O' 'zz')! !

!WAComplexRouteTest methodsFor: 'tests' stamp: 'pmm 9/6/2009 23:30'!
testInstantiation
	WAUrl absolute: '/{3}/_all_docs?startkey={1}&limit={2}'! !

!WAComplexRouteTest methodsFor: 'tests' stamp: 'pmm 9/1/2012 16:03'!
testOverlyComplexMatching
	| route arguments |
	route := WAComplexRoute
		method: 'GET'
		selector: #zork
		pattern: '/*first*/[methods.mcz|classes.mcz]'
		arguments: #('first')
		produces: nil
		consumes: nil.
	self assert: (route matchesPath: #('first' 'prefixO' 'zzpostfix' 'methods.mcz')).
	self assert: (route matchesPath: #('methods.mcz')).
	self deny: (route matchesPath: #('first' 'prefixO' 'zzpostfix' 'traits.mcz')).
	arguments := Array new: 1.
	route
		mapArgumentsWithElements: #('first' 'prefixO' 'zzpostfix' 'methods.mcz')
		parameters: Dictionary new
		into: arguments.
	self assert: arguments = #(('first' 'prefixO' 'zzpostfix')).
	arguments := Array new: 1.
	route
		mapArgumentsWithElements: #('methods.mcz')
		parameters: Dictionary new
		into: arguments.
	self assert: arguments = #(()).
	
	route := WAComplexRoute
		method: 'GET'
		selector: #zork
		pattern: '/prefix/*first*/{postfix}/[methods.mcz|classes.mcz]'
		arguments: #('first' 'postfix')
		produces: nil
		consumes: nil.
	self assert: (route matchesPath: #('prefix' 'first' 'prefixO' 'zzpostfix' 'postfix' 'methods.mcz')).
	self assert: (route matchesPath: #('prefix' 'postfix' 'methods.mcz')).
	
	arguments := Array new: 2.
	route
		mapArgumentsWithElements: #('prefix' 'first' 'prefixO' 'zzpostfix' 'postfix' 'methods.mcz')
		parameters: Dictionary new
		into: arguments.
	self assert: arguments = #(('first' 'prefixO' 'zzpostfix') 'postfix').
	arguments := Array new: 2.
	route
		mapArgumentsWithElements: #('prefix' 'postfix' 'methods.mcz')
		parameters: Dictionary new
		into: arguments.
	self assert: arguments = #(() 'postfix')! !

!WAComplexRouteTest methodsFor: 'tests' stamp: 'pmm 9/1/2012 16:03'!
testParameterMatchingMixedParameters
	| route parameters |
	route := WARoute get: '/{1}/_all_docs?rev={2}&uuids=true' selector: #a:b:.
	self deny: (route matchesParameters: Dictionary new).
	parameters := Dictionary new at: 'rev' put: '5'; yourself.
	self deny: (route matchesParameters: parameters).
	parameters at: 'uuids' put: 'true'.
	self assert: (route matchesParameters: parameters).
	parameters at: 'phpsessionid' put: '32432'.
	self deny: (route matchesParameters: Dictionary new).
	parameters removeKey: 'phpsessionid'.
	self assert: (route matchesParameters: parameters).
	parameters at: 'uuids' put: 'false'.
	self deny: (route matchesParameters: parameters)! !

!WAComplexRouteTest methodsFor: 'tests' stamp: 'pmm 9/8/2009 17:17'!
testParameterMatchingNoParameters
	| route parameters |
	route := WARoute get: '/{1}/_all_docs' selector: #a:.
	self assert: (route matchesParameters: Dictionary new).
	parameters := Dictionary new at: 'key' put: 'value'; yourself.
	self deny: (route matchesParameters: parameters)! !

!WAComplexRouteTest methodsFor: 'tests' stamp: 'pmm 9/1/2012 16:03'!
testPathMatching
	| route |
	route := WARoute get: '/{1}/_all_docs' selector: #a:.
	self deny: (route matchesPath: #('something')).
	self assert: (route matchesPath: #('something' '_all_docs')).
	self deny: (route matchesPath: #('something' 'else')).
	self deny: (route matchesPath: #('something' '_all_docs' 'more')).
	self assert: (route priority = 5)! !

TestCase subclass: #WACompositeMimeTypeMatchTest
	instanceVariableNames: 'match'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-REST-Core'!

!WACompositeMimeTypeMatchTest methodsFor: 'running' stamp: 'pmm 10/17/2010 14:17'!
setUp
	match := WACompositeMimeTypeMatch matches: (Array with:
		(WAMimeTypeMatch fromString: 'text/*'))! !

!WACompositeMimeTypeMatchTest methodsFor: 'tests' stamp: 'pmm 9/1/2012 16:05'!
testMatches
	self assert: (match matches: (WAMimeType fromString: 'text/plain')).
	self deny: (match matches: (WAMimeType fromString: 'application/json'))! !

!WACompositeMimeTypeMatchTest methodsFor: 'tests' stamp: 'pmm 10/17/2010 14:18'!
testPriorityFor
	match := WACompositeMimeTypeMatch matches: (Array
		with: (WAMimeTypeMatch fromString: 'application/*')
		with: (WAMimeTypeMatch fromString: '*/*')).
	self assert: (match priorityFor: (WAMimeType fromString: 'application/json')) = 2! !

TestCase subclass: #WAExactParameterMatchTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-REST-Core'!

!WAExactParameterMatchTest methodsFor: 'tests' stamp: 'pmm 6/13/2010 09:54'!
testInstantiation
	| match |
	match := WAParameterMatch name: 'rev' value: '58692' arguments: #().
	self assert: (match isKindOf: WAExactParameterMatch)! !

!WAExactParameterMatchTest methodsFor: 'tests' stamp: 'pmm 9/1/2012 16:19'!
testMatches
	| match |
	match := WAParameterMatch name: 'rev' value: '58692' arguments: #().
	self assert: (match matchesName: 'rev' value: '58692').
	self deny: (match matchesName: 'rev' value: 58692).
	self deny: (match matchesName: 'rev' value: 'a').
	self deny: (match matchesName: 'revision' value: '58692')! !

TestCase subclass: #WAExactPathMatchTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-REST-Core'!

!WAExactPathMatchTest methodsFor: 'tests' stamp: 'pmm 9/1/2012 16:19'!
testInstantiation
	| match |
	match := WAPPathMatch fromString: 'path' index: 1 arguments: #().
	self assert: (match isKindOf: WAExactPathMatch).
	self assert: match priority = 3! !

!WAExactPathMatchTest methodsFor: 'tests' stamp: 'pmm 6/13/2010 09:31'!
testMatches
	| match |
	match := WAPPathMatch fromString: 'path' index: 1 arguments: #().
	self assert: (match matches: 'path').
	self deny: (match matches: 'poth')! !

TestCase subclass: #WAFullMimeTypeMatchTest
	instanceVariableNames: 'match'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-REST-Core'!

!WAFullMimeTypeMatchTest methodsFor: 'running' stamp: 'pmm 10/6/2010 12:45'!
setUp
	match := WAFullMimeTypeMatch main: 'application' sub: 'xml'! !

!WAFullMimeTypeMatchTest methodsFor: 'tests' stamp: 'pmm 10/6/2010 12:45'!
testMatches
	self assert: (match matches: (WAMimeType main: 'application' sub: 'xml')).
	self deny: (match matches: (WAMimeType main: 'something' sub: 'xml')).
	self deny: (match matches: (WAMimeType main: 'application' sub: 'something')).
	self deny: (match matches: (WAMimeType main: 'something' sub: 'something')).
	
	self assert: (match matches: (WAMimeType main: '*' sub: 'xml')).
	self assert: (match matches: (WAMimeType main: 'application' sub: '*')).
	self assert: (match matches: (WAMimeType main: '*' sub: '*')).
	
	self deny: (match matches: (WAMimeType main: 'something' sub: '*')).
	self deny: (match matches: (WAMimeType main: '*' sub: 'something'))! !

!WAFullMimeTypeMatchTest methodsFor: 'tests' stamp: 'pmm 10/6/2010 12:45'!
testPriority
	self assert: match priority = 3! !

TestCase subclass: #WAMainMimeTypeMatchTest
	instanceVariableNames: 'match'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-REST-Core'!

!WAMainMimeTypeMatchTest methodsFor: 'running' stamp: 'pmm 10/6/2010 12:46'!
setUp
	match := WAMainMimeTypeMatch main: 'application'! !

!WAMainMimeTypeMatchTest methodsFor: 'tests' stamp: 'pmm 10/6/2010 12:46'!
testMatches
	self assert: (match matches: (WAMimeType main: 'application' sub: 'xml')).
	self deny: (match matches: (WAMimeType main: 'something' sub: 'xml')).
	self assert: (match matches: (WAMimeType main: 'application' sub: 'something')).
	self deny: (match matches: (WAMimeType main: 'something' sub: 'something')).
	
	self assert: (match matches: (WAMimeType main: '*' sub: 'xml')).
	self assert: (match matches: (WAMimeType main: 'application' sub: '*')).
	self assert: (match matches: (WAMimeType main: '*' sub: '*')).
	
	self deny: (match matches: (WAMimeType main: 'something' sub: '*')).
	self assert: (match matches: (WAMimeType main: '*' sub: 'something'))! !

!WAMainMimeTypeMatchTest methodsFor: 'tests' stamp: 'pmm 10/6/2010 12:46'!
testPriority
	self assert: match priority = 2! !

TestCase subclass: #WAMimeTypeMatchTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-REST-Core'!

!WAMimeTypeMatchTest methodsFor: 'tests' stamp: 'pmm 10/17/2010 14:18'!
testFromMimeType
	| mimeType |
	mimeType := WAMimeTypeMatch fromString: 'application/xml'.
	self assert: mimeType class = WAFullMimeTypeMatch.
	
	mimeType := WAMimeTypeMatch fromString: 'application/*'.
	self assert: mimeType class = WAMainMimeTypeMatch.
	
	mimeType := WAMimeTypeMatch fromString: '*/xml'.
	self assert: mimeType class = WASubMimeTypeMatch.
	
	mimeType := WAMimeTypeMatch fromString: '*/*'.
	self assert: mimeType class = WAWildcardMimeTypeMatch! !

TestCase subclass: #WAMimeTypeStubHandlerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-REST-Core'!

!WAMimeTypeStubHandlerTest methodsFor: 'private' stamp: 'pmm 8/28/2012 10:36'!
assertContentType: aMimeTypeStringOrNil accept: anAcceptStringOrNil produces: aProducedMimeTypeStringOrNil
	| routes headers request context result |
	routes := WAByMethodRoutes routes: (GRPlatform current createRoutesFor: WAMimeTypeStubHandler).
	headers := GRSmallDictionary new.
	aMimeTypeStringOrNil isNil ifFalse: [
		headers at: 'content-type' put: aMimeTypeStringOrNil ].
	anAcceptStringOrNil isNil ifFalse: [
		headers at: 'accept' put: anAcceptStringOrNil ].
	request := (WARequest method: 'GET' uri: 'index')
		setHeaders: headers;
		yourself.
	context := WARequestContext request: request response: WAResponse new.
	result := routes routeForContext: context consume: true ifAbsent: [ self fail ].
	self assert: result seasideMimeType = (aProducedMimeTypeStringOrNil isNil
		ifTrue: [ nil ]
		ifFalse: [  WAMimeType fromString: aProducedMimeTypeStringOrNil ])! !

!WAMimeTypeStubHandlerTest methodsFor: 'private' stamp: 'pmm 8/28/2012 10:33'!
assertContentType: aMimeTypeStringOrNil accept: anAcceptStringOrNil routesTo: aSymbol
	| routes headers request context result |
	routes := WAByMethodRoutes routes: (GRPlatform current createRoutesFor: WAMimeTypeStubHandler).
	headers := GRSmallDictionary new.
	aMimeTypeStringOrNil isNil ifFalse: [
		headers at: 'content-type' put: aMimeTypeStringOrNil ].
	anAcceptStringOrNil isNil ifFalse: [
		headers at: 'accept' put: anAcceptStringOrNil ].
	request := (WARequest method: 'GET' uri: 'index')
		setHeaders: headers;
		yourself.
	context := WARequestContext request: request response: WAResponse new.
	result := routes routeForContext: context consume: true ifAbsent: [ self fail ].
	self assert: result route selector = aSymbol! !

!WAMimeTypeStubHandlerTest methodsFor: 'tests' stamp: 'pmm 9/1/2012 16:33'!
testMultipleConentTypeRouting
	self assertContentType: 'foo/bar' accept: nil routesTo: #processTwo.
	self assertContentType: 'zork/fnord' accept: nil routesTo: #processTwo! !

!WAMimeTypeStubHandlerTest methodsFor: 'tests' stamp: 'pmm 9/1/2012 16:32'!
testProduceMimeType
	self assertContentType: nil accept: 'image/jpeg' produces: 'image/jpeg'.
	self assertContentType: nil accept: 'image/png' produces: 'image/png'! !

!WAMimeTypeStubHandlerTest methodsFor: 'tests' stamp: 'pmm 7/28/2011 21:26'!
testProduceNoMimeType
	self assertContentType: 'application/xml' accept: nil produces: nil! !

!WAMimeTypeStubHandlerTest methodsFor: 'tests' stamp: 'pmm 9/1/2012 16:33'!
testSimpleAcceptRouting
	self assertContentType: nil accept: 'image/jpeg;q=0.8,image/png' routesTo: #producePng.
	self assertContentType: nil accept: 'image/jpeg;q=0.8,image/png;q=0.9' routesTo: #producePng.
	self assertContentType: nil accept: 'image/png,image/jpeg;q=0.8' routesTo: #producePng.
	self assertContentType: nil accept: 'image/png;q=0.9,image/jpeg;q=0.8' routesTo: #producePng.
	
	self assertContentType: '1/1' accept: 'image/png' routesTo: #producePng.
	self assertContentType: '1/1' accept: 'image/png' routesTo: #producePng! !

!WAMimeTypeStubHandlerTest methodsFor: 'tests' stamp: 'pmm 9/1/2012 16:33'!
testSimpleConentTypeRouting
	self assertContentType: 'application/xml' accept: nil routesTo: #processApplicationXml.
	self assertContentType: 'text/xml' accept: nil routesTo: #processXml! !

TestCase subclass: #WAOrPathMatchTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-REST-Core'!

!WAOrPathMatchTest methodsFor: 'tests' stamp: 'pmm 9/1/2012 16:34'!
testInstantiation
	| match |
	match := WAOrPathMatch fromString: 'path' index: 1 arguments: #().
	self assert: (match isKindOf: WAOrPathMatch).
	self assert: match priority = 3! !

!WAOrPathMatchTest methodsFor: 'tests' stamp: 'pmm 3/21/2011 21:15'!
testMatches
	| match |
	match := WAOrPathMatch fromString: '[path|parameters]' index: 1 arguments: #().
	self assert: (match matches: 'path').
	self assert: (match matches: 'parameters').
	self deny: (match matches: 'poth').
	
	match := WAOrPathMatch fromString: '[path|or|parameters]' index: 1 arguments: #().
	self assert: (match matches: 'path').
	self assert: (match matches: 'parameters').
	self assert: (match matches: 'or').
	self deny: (match matches: 'poth')! !

TestCase subclass: #WAPlaceholderParameterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-REST-Core'!

!WAPlaceholderParameterTest methodsFor: 'tests' stamp: 'pmm 6/13/2010 09:57'!
testInstantiation
	| match |
	match := WAParameterMatch name: 'rev' value: '{1}' arguments: #().
	self assert: (match isKindOf: WAPlaceholderParameterMatch).
	self assert: match index = 1! !

!WAPlaceholderParameterTest methodsFor: 'tests' stamp: 'pmm 9/1/2012 16:36'!
testMatches
	| match |
	match := WAParameterMatch name: 'rev' value: '{1}' arguments: #().
	self assert: (match matchesName: 'rev' value: '58692').
	self assert: (match matchesName: 'rev' value: 'a').
	self deny: (match matchesName: 'revision' value: '58692')! !

!WAPlaceholderParameterTest methodsFor: 'tests' stamp: 'pmm 6/13/2010 09:54'!
testNamedInstantiation
	| match |
	match := WAParameterMatch name: 'rev' value: '{put}' arguments: #('post' 'put' 'get').
	self assert: (match isKindOf: WAPlaceholderParameterMatch).
	self assert: match index = 2! !

TestCase subclass: #WAPlaceholderPathMatchTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-REST-Core'!

!WAPlaceholderPathMatchTest methodsFor: 'tests' stamp: 'pmm 9/1/2012 16:37'!
testFullInstantiation
	| match |
	match := WAPPathMatch fromString: '{7}' index: 2 arguments: #().
	self assert: (match isKindOf: WAFullPlaceholderPathMatch).
	self assert: match priority = 2.
	self assert: match sourceIndex = 2.
	self assert: match targetIndex = 7! !

!WAPlaceholderPathMatchTest methodsFor: 'tests' stamp: 'pmm 6/30/2010 07:38'!
testFullMapArgumentsWithElementsInto
	| match result |
	match := WAPPathMatch fromString: '{1}' index: 1 arguments: #().
	result := Array new: 1.
	match mapArgumentsWithElements: #('foo') into: result.
	self assert: result first = 'foo'! !

!WAPlaceholderPathMatchTest methodsFor: 'tests' stamp: 'pmm 6/26/2010 17:49'!
testMatchesFull
	| match |
	match := WAPPathMatch fromString: '{7}' index: 1 arguments: #().
	self assert: (match matches: 'foo')! !

!WAPlaceholderPathMatchTest methodsFor: 'tests' stamp: 'pmm 9/1/2012 16:36'!
testMatchesPrefix
	| match |
	match := WAPPathMatch fromString: 'foo.{7}' index: 1 arguments: #().
	self assert: (match matches: 'foo.bar').
	self deny: (match matches: 'foo.').
	self deny: (match matches: 'fo.bar').
	self deny: (match matches: 'oo.bar')! !

!WAPlaceholderPathMatchTest methodsFor: 'tests' stamp: 'pmm 9/1/2012 16:37'!
testMatchesSuffix
	| match |
	match := WAPPathMatch fromString: '{7}.bar' index: 1 arguments: #().
	self assert: (match matches: 'foo.bar').
	self deny: (match matches: '.bar').
	self deny: (match matches: 'foo.barz').
	self deny: (match matches: 'foo.ba')! !

!WAPlaceholderPathMatchTest methodsFor: 'tests' stamp: 'pmm 9/1/2012 16:37'!
testMultiInstantiation
	| match |
	match := WAPPathMatch fromString: '*7*' index: 2 arguments: #().
	self assert: (match isKindOf: WAMultiPlaceholderPathMatch).
	self assert: match priority = 1.
	self assert: match sourceIndex = 2.
	self assert: match targetIndex = 7! !

!WAPlaceholderPathMatchTest methodsFor: 'tests' stamp: 'pmm 9/1/2012 16:37'!
testNamedInstantiation
	| match |
	match := WAPPathMatch fromString: '{put}' index: 2 arguments: #('get' 'put' 'post').
	self assert: (match isKindOf: WAFullPlaceholderPathMatch).
	self assert: match priority = 2.
	self assert: match sourceIndex = 2.
	self assert: match targetIndex = 2! !

!WAPlaceholderPathMatchTest methodsFor: 'tests' stamp: 'pmm 9/1/2012 16:38'!
testNamedMultiInstantiation
	| match |
	match := WAPPathMatch fromString: '*put*' index: 2 arguments: #('get' 'put' 'post').
	self assert: (match isKindOf: WAMultiPlaceholderPathMatch).
	self assert: match priority = 1.
	self assert: match sourceIndex = 2.
	self assert: match targetIndex = 2! !

!WAPlaceholderPathMatchTest methodsFor: 'tests' stamp: 'pmm 9/1/2012 16:37'!
testPrefixInstantiation
	| match |
	match := WAPPathMatch fromString: 'foo.{787}' index: 2 arguments: #().
	self assert: (match isKindOf: WAPrefixPlaceholderPathMatch).
	self assert: match priority = 3.
	self assert: match sourceIndex = 2.
	self assert: match targetIndex = 787! !

!WAPlaceholderPathMatchTest methodsFor: 'tests' stamp: 'pmm 6/30/2010 07:38'!
testPrefixMapArgumentsWithElementsInto
	| match result |
	match := WAPPathMatch fromString: 'foo.{1}' index: 1 arguments: #().
	result := Array new: 1.
	match mapArgumentsWithElements: #('foo.bar') into: result.
	self assert: result first = 'bar'! !

!WAPlaceholderPathMatchTest methodsFor: 'tests' stamp: 'pmm 9/1/2012 16:37'!
testSuffixInstantiation
	| match |
	match := WAPPathMatch fromString: '{787}.bar' index: 2 arguments: #().
	self assert: (match isKindOf: WASuffixPlaceholderPathMatch).
	self assert: match priority = 3.
	self assert: match sourceIndex = 2.
	self assert: match targetIndex = 787! !

!WAPlaceholderPathMatchTest methodsFor: 'tests' stamp: 'pmm 6/30/2010 07:38'!
testSuffixMapArgumentsWithElementsInto
	| match result |
	match := WAPPathMatch fromString: '{1}.bar' index: 1 arguments: #().
	result := Array new: 1.
	match mapArgumentsWithElements: #('foo.bar') into: result.
	self assert: result first = 'foo'! !

TestCase subclass: #WAPragmaBasedRestfulHandlerTest
	instanceVariableNames: 'handler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-REST-Core'!

!WAPragmaBasedRestfulHandlerTest methodsFor: 'running' stamp: 'pmm 5/31/2010 20:32'!
setUp
	handler := WAPragmaStubHandler new! !

!WAPragmaBasedRestfulHandlerTest methodsFor: 'tests' stamp: 'pmm 5/31/2010 20:32'!
testCreateRoutes
	self assert: handler notNil! !

TestCase subclass: #WARouteTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-REST-Core'!

!WARouteTest methodsFor: 'tests' stamp: 'pmm 9/8/2009 22:26'!
testCount
	| route |
	route := WARoute get: #listDatabases.
	self assert: route pathElementCount isZero.
	
	route := WARoute get: #getDatabase:.
	self assert: route pathElementCount = 1.
	
	route := WARoute get: #getDatabase:document:.
	self assert: route pathElementCount = 2! !

!WARouteTest methodsFor: 'tests' stamp: 'pmm 9/8/2009 22:19'!
testMethod
	| route |
	route := WARoute get: #listDatabases.
	self assert: route method = 'GET'.
	
	route := WARoute post: #createDatabase:document:.
	self assert: route method = 'POST'.
	
	route := WARoute copy: #copyDatabase:document:.
	self assert: route method = 'COPY'! !

!WARouteTest methodsFor: 'tests' stamp: 'pmm 9/1/2012 16:51'!
testSendSelectorWithTo
	| route victim result |
	victim := WARouteVictimMock new.
	route := WARoute get: #nothing.
	result := route sendSelectorWith: Array new to: victim.
	self assert: result = Array new.
	
	route := WARoute get: #first:.
	result := route sendSelectorWith: #('terrorists') to: victim.
	self assert: result = #('terrorists').
	
	route := WARoute get: #first:second:.
	result := route sendSelectorWith: #('terrorists' 'marschall') to: victim.
	self assert: result = #('terrorists' 'marschall')! !

TestCase subclass: #WASimpleRouteTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-REST-Core'!

!WASimpleRouteTest methodsFor: 'tests' stamp: 'pmm 9/8/2009 17:17'!
testParameterMatching
	| route parameters |
	route := WARoute get: #a:.
	self assert: (route matchesParameters: Dictionary new).
	parameters := Dictionary new at: 'key' put: 'value'; yourself.
	self deny: (route matchesParameters: parameters)! !

!WASimpleRouteTest methodsFor: 'tests' stamp: 'pmm 9/8/2009 13:01'!
testPathMatching
	| route |
	route := WARoute get: #a:.
	self deny: (route matchesPath: Array new).
	self assert: (route matchesPath: #('something')).
	self deny: (route matchesPath: #('something' 'else')).
	self assert: (route priority = 1).
	
	route := WARoute get: #a:b:.
	self deny: (route matchesPath: Array new).
	self deny: (route matchesPath: #('something')).
	self assert: (route matchesPath: #('something' 'else')).
	self deny: (route matchesPath: #('something' 'else' 'more')).
	self assert: (route priority = 2)! !

TestCase subclass: #WASubMimeTypeMatchTest
	instanceVariableNames: 'match'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-REST-Core'!

!WASubMimeTypeMatchTest methodsFor: 'running' stamp: 'pmm 10/6/2010 12:46'!
setUp
	match := WASubMimeTypeMatch sub: 'xml'! !

!WASubMimeTypeMatchTest methodsFor: 'tests' stamp: 'pmm 10/6/2010 12:46'!
testMatches
	self assert: (match matches: (WAMimeType main: 'application' sub: 'xml')).
	self assert: (match matches: (WAMimeType main: 'something' sub: 'xml')).
	self deny: (match matches: (WAMimeType main: 'application' sub: 'something')).
	self deny: (match matches: (WAMimeType main: 'something' sub: 'something')).
	
	self assert: (match matches: (WAMimeType main: '*' sub: 'xml')).
	self assert: (match matches: (WAMimeType main: 'application' sub: '*')).
	self assert: (match matches: (WAMimeType main: '*' sub: '*')).
	
	self assert: (match matches: (WAMimeType main: 'something' sub: '*')).
	self deny: (match matches: (WAMimeType main: '*' sub: 'something'))! !

!WASubMimeTypeMatchTest methodsFor: 'tests' stamp: 'pmm 10/6/2010 12:46'!
testPriority
	self assert: match priority = 2! !

TestCase subclass: #WAWildcardMimeTypeMatchTest
	instanceVariableNames: 'match'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-REST-Core'!

!WAWildcardMimeTypeMatchTest methodsFor: 'running' stamp: 'pmm 10/6/2010 12:46'!
setUp
	match := WAWildcardMimeTypeMatch new! !

!WAWildcardMimeTypeMatchTest methodsFor: 'tests' stamp: 'pmm 10/6/2010 12:46'!
testMatches
	self assert: (match matches: (WAMimeType main: 'application' sub: 'xml')).
	self assert: (match matches: (WAMimeType main: 'something' sub: 'xml')).
	self assert: (match matches: (WAMimeType main: 'application' sub: 'something')).
	self assert: (match matches: (WAMimeType main: 'something' sub: 'something')).
	
	self assert: (match matches: (WAMimeType main: '*' sub: 'xml')).
	self assert: (match matches: (WAMimeType main: 'application' sub: '*')).
	self assert: (match matches: (WAMimeType main: '*' sub: '*'))! !

!WAWildcardMimeTypeMatchTest methodsFor: 'tests' stamp: 'pmm 10/6/2010 12:46'!
testPriority
	self assert: match priority = 1! !

WARestfulFilter subclass: #WAStubFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-REST-Core'!

!WAStubFilter methodsFor: 'private' stamp: 'pmm 2/18/2012 14:12'!
createRoutes
	^ OrderedCollection new
		"GET"
		add: (WARoute get: #listDatabases);
		add: (WARoute post: #createDatabase:);
		add: (WARoute post: #createDatabase:document:);
		add: (WARoute get: #getDatabase:document:);
		add: (WARoute delete: #deleteDatabase:document:);
		yourself! !

WAContextTest subclass: #WARestfulFilterTest
	instanceVariableNames: 'handler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-REST-Core'!

!WARestfulFilterTest methodsFor: 'running' stamp: 'pmm 2/18/2012 14:15'!
setUp
	super setUp.
	handler := WAStubFilter new! !

!WARestfulFilterTest methodsFor: 'tests' stamp: 'pmm 2/18/2012 14:14'!
testFindRouteForMethodConsumerIfAbsent
	| route result requestUrl request context |
	requestUrl := WAUrl new
		addAllToPath: #('users' 'marschall');
		yourself.
	request := WARequest
		method: 'GET'
		uri: requestUrl.
	context := WARequestContext request: request response: WAResponse new.
	result := handler routeForContext: context ifAbsent: [ self assert: false ].
	route := result route.
	self assert: route method = 'GET'.
	self assert: route pathElementCount = 2.
	self assert: route selector = #getDatabase:document:.
	self assert: result elements = #('users' 'marschall').
	self deny: context consumer atEnd! !

WAContextTest subclass: #WARestfulHandlerTest
	instanceVariableNames: 'handler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-REST-Core'!

!WARestfulHandlerTest methodsFor: 'running' stamp: 'pmm 9/8/2009 22:21'!
setUp
	super setUp.
	handler := WAStubHandler new! !

!WARestfulHandlerTest methodsFor: 'tests' stamp: 'pmm 2/18/2012 14:14'!
testFindRouteForMethodConsumerIfAbsent
	| route result requestUrl request context |
	requestUrl := WAUrl new
		addAllToPath: #('users' 'marschall');
		yourself.
	request := WARequest
		method: 'GET'
		uri: requestUrl.
	context := WARequestContext request: request response: WAResponse new.
	result := handler routeForContext: context ifAbsent: [ self assert: false ].
	route := result route.
	self assert: route method = 'GET'.
	self assert: route pathElementCount = 2.
	self assert: route selector = #getDatabase:document:.
	self assert: result elements = #('users' 'marschall').
	self assert: context consumer atEnd! !

WAContextTest subclass: #WAStreamTypeHandlerTest
	instanceVariableNames: 'handler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-REST-Core'!

!WAStreamTypeHandlerTest methodsFor: 'private' stamp: 'pmm 8/19/2012 11:01'!
assertPerformGetTo: aCollectionOfStrings equals: aCollection contentType: aMimeType
	| requestUrl request response context |
	requestUrl := WAUrl new
		addAllToPath: aCollectionOfStrings;
		yourself.
	request := WARequest
		method: 'GET'
		uri: requestUrl.
	response := WABufferedResponse new.
		
	context := WARequestContext request: request response: response.
	[ handler handle: context ]
		on: WAResponseNotification
		do: [ :n | ].
	
	self assert: response contents = aCollection.
	aMimeType isNil ifFalse: [
		self assert: response contentType = aMimeType.
		self assert: response contentType greaseString = aMimeType greaseString ]! !

!WAStreamTypeHandlerTest methodsFor: 'running' stamp: 'pmm 2/18/2012 17:48'!
setUp
	super setUp.
	handler := WAStreamTypeHandler new! !

!WAStreamTypeHandlerTest methodsFor: 'tests' stamp: 'pmm 8/19/2012 10:33'!
testFaviconIco
	self assertPerformGetTo: #('favicon.ico') equals: handler faviconIco contentType: nil! !

!WAStreamTypeHandlerTest methodsFor: 'tests' stamp: 'pmm 8/28/2012 10:29'!
testIndex
	self assertPerformGetTo: #('index') equals: handler index contentType: nil! !

!WAStreamTypeHandlerTest methodsFor: 'tests' stamp: 'pmm 8/19/2012 10:35'!
testRobotsTxt
	self assertPerformGetTo: #('robots.txt') equals: handler robotsTxt contentType: (WAMimeType fromString: 'text/plain;charset=utf-8')! !

!WAStreamTypeHandlerTest methodsFor: 'tests' stamp: 'pmm 8/19/2012 10:34'!
testStarGif
	self assertPerformGetTo: #('star.gif') equals: handler starGif contentType: (WAMimeType fromString: 'image/gif')! !

WARestfulHandler subclass: #WAMimeTypeStubHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-REST-Core'!

!WAMimeTypeStubHandler methodsFor: 'request-handling' stamp: 'pmm 8/28/2012 10:31'!
processApplicationXml
	<get>
	<path: 'index'>
	<consumes: 'application/xml'>
	! !

!WAMimeTypeStubHandler methodsFor: 'request-handling' stamp: 'pmm 8/28/2012 10:31'!
processTwo
	<get>
	<path: 'index'>
	<consumes: 'foo/bar'>
	<consumes: 'zork/fnord'>
	! !

!WAMimeTypeStubHandler methodsFor: 'request-handling' stamp: 'pmm 8/28/2012 10:32'!
processXml
	<get>
	<path: 'index'>
	<consumes: '*/xml'>
	! !

!WAMimeTypeStubHandler methodsFor: 'request-handling' stamp: 'pmm 8/28/2012 10:32'!
produceJpeg
	<get>
	<path: 'index'>
	<produces: 'image/jpeg'>
	! !

!WAMimeTypeStubHandler methodsFor: 'request-handling' stamp: 'pmm 8/28/2012 10:32'!
producePng
	<get>
	<path: 'index'>
	<produces: 'image/png'>
	! !

WARestfulHandler subclass: #WAPragmaStubHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-REST-Core'!

!WAPragmaStubHandler methodsFor: 'public-database' stamp: 'lr 7/26/2011 11:50'!
compactDatabase: databaseName
	<post>
	<path: '/{databaseName}/_compact'>
	! !

!WAPragmaStubHandler methodsFor: 'public-documents' stamp: 'lr 7/26/2011 11:50'!
createBulkDocumentsInDatabase: databaseName
	<post>
	<path: '/{databaseName}/_bulk_docs'>
	! !

!WAPragmaStubHandler methodsFor: 'public-database' stamp: 'lr 7/26/2011 11:50'!
createDatabase: databaseName
	<put>
	! !

!WAPragmaStubHandler methodsFor: 'public-documents' stamp: 'lr 7/26/2011 11:50'!
createNewDocumentInDatabase: databaseName
	<post>
	! !

!WAPragmaStubHandler methodsFor: 'public-documents' stamp: 'lr 7/26/2011 11:50'!
createOrUpdateDocument: documentId inDatabase: databaseName
	<put>
	<path: '/{databaseName}/{documentId}'>
	! !

!WAPragmaStubHandler methodsFor: 'public-database' stamp: 'lr 7/26/2011 11:50'!
deleteDatabase: databaseName
	<delete>
	! !

!WAPragmaStubHandler methodsFor: 'public-documents' stamp: 'lr 7/26/2011 11:50'!
deleteDocument: documentId inDatabase: databaseName
	<delete>
	<path: '/{databaseName}/{documentId}'>
	! !

!WAPragmaStubHandler methodsFor: 'public-meta' stamp: 'lr 7/26/2011 11:50'!
getAllDatabases
	<get>
	<path: '/_all_dbs'>
	! !

!WAPragmaStubHandler methodsFor: 'public-documents' stamp: 'lr 7/26/2011 11:50'!
getAllDocuments: databaseName
	<get>
	<path: '/{databaseName}/_all_docs'>
	! !

!WAPragmaStubHandler methodsFor: 'public-meta' stamp: 'lr 7/26/2011 11:50'!
getConfig
	<get>
	<path: '/_config'>
	! !

!WAPragmaStubHandler methodsFor: 'public-database' stamp: 'lr 7/26/2011 11:50'!
getDatabase: databaseName
	<get>
	! !

!WAPragmaStubHandler methodsFor: 'public-documents' stamp: 'lr 7/26/2011 11:50'!
getDocument: documentId ofDatabase: databaseName
	<get>
	<path: '/{databaseName}/{documentId}'>
	! !

!WAPragmaStubHandler methodsFor: 'public-meta' stamp: 'lr 7/26/2011 11:50'!
getInfo
	<get>
	! !

!WAPragmaStubHandler methodsFor: 'public-meta' stamp: 'lr 7/26/2011 11:50'!
getStats
	<get>
	<path: '/_stats'>
	! !

!WAPragmaStubHandler methodsFor: 'public-meta' stamp: 'lr 7/26/2011 11:50'!
getUuids: numberOfUuids
	<get>
	<path: '/_uuids?count={numberOfUuids}'>
	! !

!WAPragmaStubHandler methodsFor: 'public-documents' stamp: 'lr 7/26/2011 11:50'!
getView: viewName inDesign: designName inDatabase: databaseName
	<get>
	<path: '/{databaseName}/_design/{designName}/_view/{viewName}'>
	! !

!WAPragmaStubHandler methodsFor: 'public-documents' stamp: 'lr 7/26/2011 11:50'!
queryDatabase: databaseName
	<post>
	<path: '/{databaseName}/_temp_view'>
	! !

!WAPragmaStubHandler methodsFor: 'public-meta' stamp: 'lr 7/26/2011 11:50'!
replicate
	<post>
	<path: '/_replicate'>
	! !

WARestfulHandler subclass: #WAStreamTypeHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-REST-Core'!

!WAStreamTypeHandler methodsFor: 'request-handling' stamp: 'pmm 2/19/2012 09:32'!
faviconIco
	<get>
	<path: 'favicon.ico'>
	^ #(16r47 16r49 16r46 16r38 16r39 16r61 16rE0 16r00 16rE0 16r00 16rD5 16r3F 16r00 16rEC 16rBA 16r9C 16rFD 16r49 16r00 16rFD 16r6D 16r00 16rE4 16rAE 16rAD 16rFF 16r64 16r00 16rFE 16r74 16r00 16rFF 16r8E 16r00 16rFF 16r86 16r00 16rEA 16r8C 16r5B 16rFF 16r78 16r00 16rFE 16r5B 16r00 16rFA 16r54 16r00 16rE6 16r16 16r00 16rEC 16r2F 16r00 16rFF 16r92 16r00 16rEE 16rC8 16rAF 16rFF 16rA2 16r00 16rDA 16r7A 16r76 16rFF 16r70 16r00 16rFF 16r95 16r00 16rD6 16r68 16r68 16rFF 16r89 16r00 16rDE 16r10 16r00 16rF5 16rE7 16rE7 16rF8 16rEA 16rEA 16rF3 16rDD 16rD3 16rEF 16rD2 16rC0 16rDC 16r89 16r89 16rEB 16r9F 16r6B 16rF7 16r58 16rA0 16rFF 16r9A 16r00 16rFB 16rFB 16rFB 16rE1 16r80 16r00 16rDC 16rF0 16rA0 16rD8 16r43 16r3D 16rDF 16rA7 16rA7 16rEC 16rD0 16rD0 16rD8 16r62 16r55 16rF9 16r60 16rA0 16rFA 16rF0 16rEA 16rED 16rC1 16r9D 16rEB 16r56 16r31 16rF9 16r72 16rA0 16rEB 16rC2 16rC0 16rD4 16r4A 16r4A 16rEE 16r76 16r2F 16rED 16r7B 16r3D 16rF5 16r54 16r00 16rEB 16r7E 16r4B 16rF5 16r70 16r16 16rEA 16r9A 16r7B 16rF2 16r8D 16r23 16rEA 16r9D 16r5B 16rE1 16r7C 16r67 16rED 16r64 16r30 16rF7 16rE9 16rE9 16rEA 16r90 16r6A 16rE2 16r97 16r87 16rED 16r88 16r3D 16rEE 16r25 16r00 16rDD 16r25 16r16 16rED 16r6D 16r3D 16rFF 16rA9 16r00 16rFF 16rFF 16rFF 16r21 16rF9 16r40 16r10 16r00 16r00 16r3F 16r00 16r2C 16r00 16r00 16r00 16r00 16rE0 16r00 16rE0 16r00 16r00 16r60 16r7E 16rC0 16r9F 16rF0 16r77 16r72 16r10 16r86 16r48 16rE4 16r83 16r60 16rCA 16r24 16r93 16rF0 16r41 16rA2 16r35 16rC4 16rC0 16r30 16rCA 16r43 16rC1 16r00 16r93 16rD9 16r18 16r16 16rA0 16r92 16rE3 16r28 16r40 16r26 16r15 16rC5 16r2E 16r44 16rFA 16rA1 16r68 16r33 16r87 16rEF 16r60 16r38 16r28 16rA0 16r8D 16rD1 16r4F 16r27 16r49 16r1C 16rFE 16r50 16rA0 16r40 16r13 16r20 16r11 16r42 16r00 16r31 16r12 16r15 16r13 16r60 16r90 16r82 16r60 16r2F 16r30 16r48 16r1A 16r80 16r2A 16r10 16r50 16r15 16r60 16rB0 16rB0 16r3C 16r37 16r49 16r80 16r1E 16r40 16r8D 16r78 16rC0 16r2C 16r49 16r38 16r90 16r20 16r1D 16r35 16r22 16rC0 16r20 16r16 16r2B 16r48 16r3D 16r10 16r10 16r39 16r42 16r17 16r1B 16r14 16r17 16r48 16r29 16r3B 16r25 16r4F 16r49 16r2B 16r11 16r1F 16rC0 16r41 16r00 16r3B) asByteArray! !

!WAStreamTypeHandler methodsFor: 'request-handling' stamp: 'pmm 2/18/2012 22:59'!
index
	<get>
	^ 'ok'! !

!WAStreamTypeHandler methodsFor: 'request-handling' stamp: 'pmm 2/18/2012 17:39'!
robotsTxt
	<get>
	<path: 'robots.txt'>
	<produces: 'text/plain'>
	^ 'User-agent: *
Disallow: /'! !

!WAStreamTypeHandler methodsFor: 'request-handling' stamp: 'pmm 2/18/2012 18:26'!
starGif
	<get>
	<path: 'star.gif'>
	<produces: 'image/gif'>
	^ #(16r47 16r49 16r46 16r38 16r39 16r61 16rE0 16r00 16rE0 16r00 16rD5 16r3F 16r00 16rEC 16rBA 16r9C 16rFD 16r49 16r00 16rFD 16r6D 16r00 16rE4 16rAE 16rAD 16rFF 16r64 16r00 16rFE 16r74 16r00 16rFF 16r8E 16r00 16rFF 16r86 16r00 16rEA 16r8C 16r5B 16rFF 16r78 16r00 16rFE 16r5B 16r00 16rFA 16r54 16r00 16rE6 16r16 16r00 16rEC 16r2F 16r00 16rFF 16r92 16r00 16rEE 16rC8 16rAF 16rFF 16rA2 16r00 16rDA 16r7A 16r76 16rFF 16r70 16r00 16rFF 16r95 16r00 16rD6 16r68 16r68 16rFF 16r89 16r00 16rDE 16r10 16r00 16rF5 16rE7 16rE7 16rF8 16rEA 16rEA 16rF3 16rDD 16rD3 16rEF 16rD2 16rC0 16rDC 16r89 16r89 16rEB 16r9F 16r6B 16rF7 16r58 16rA0 16rFF 16r9A 16r00 16rFB 16rFB 16rFB 16rE1 16r80 16r00 16rDC 16rF0 16rA0 16rD8 16r43 16r3D 16rDF 16rA7 16rA7 16rEC 16rD0 16rD0 16rD8 16r62 16r55 16rF9 16r60 16rA0 16rFA 16rF0 16rEA 16rED 16rC1 16r9D 16rEB 16r56 16r31 16rF9 16r72 16rA0 16rEB 16rC2 16rC0 16rD4 16r4A 16r4A 16rEE 16r76 16r2F 16rED 16r7B 16r3D 16rF5 16r54 16r00 16rEB 16r7E 16r4B 16rF5 16r70 16r16 16rEA 16r9A 16r7B 16rF2 16r8D 16r23 16rEA 16r9D 16r5B 16rE1 16r7C 16r67 16rED 16r64 16r30 16rF7 16rE9 16rE9 16rEA 16r90 16r6A 16rE2 16r97 16r87 16rED 16r88 16r3D 16rEE 16r25 16r00 16rDD 16r25 16r16 16rED 16r6D 16r3D 16rFF 16rA9 16r00 16rFF 16rFF 16rFF 16r21 16rF9 16r40 16r10 16r00 16r00 16r3F 16r00 16r2C 16r00 16r00 16r00 16r00 16rE0 16r00 16rE0 16r00 16r00 16r60 16r7E 16rC0 16r9F 16rF0 16r77 16r72 16r10 16r86 16r48 16rE4 16r83 16r60 16rCA 16r24 16r93 16rF0 16r41 16rA2 16r35 16rC4 16rC0 16r30 16rCA 16r43 16rC1 16r00 16r93 16rD9 16r18 16r16 16rA0 16r92 16rE3 16r28 16r40 16r26 16r15 16rC5 16r2E 16r44 16rFA 16rA1 16r68 16r33 16r87 16rEF 16r60 16r38 16r28 16rA0 16r8D 16rD1 16r4F 16r27 16r49 16r1C 16rFE 16r50 16rA0 16r40 16r13 16r20 16r11 16r42 16r00 16r31 16r12 16r15 16r13 16r60 16r90 16r82 16r60 16r2F 16r30 16r48 16r1A 16r80 16r2A 16r10 16r50 16r15 16r60 16rB0 16rB0 16r3C 16r37 16r49 16r80 16r1E 16r40 16r8D 16r78 16rC0 16r2C 16r49 16r38 16r90 16r20 16r1D 16r35 16r22 16rC0 16r20 16r16 16r2B 16r48 16r3D 16r10 16r10 16r39 16r42 16r17 16r1B 16r14 16r17 16r48 16r29 16r3B 16r25 16r4F 16r49 16r2B 16r11 16r1F 16rC0 16r41 16r00 16r3B) asByteArray! !

WARestfulHandler subclass: #WAStubHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-REST-Core'!

!WAStubHandler methodsFor: 'private' stamp: 'lr 7/26/2011 12:22'!
createRoutes
	^ OrderedCollection new
		"GET"
		add: (WARoute get: #listDatabases);
		add: (WARoute post: #createDatabase:);
		add: (WARoute post: #createDatabase:document:);
		add: (WARoute get: #getDatabase:document:);
		add: (WARoute delete: #deleteDatabase:document:);
		yourself! !

!GRPackage class methodsFor: '*seaside-tests-rest-core' stamp: 'pmm 5/8/2012 19:11'!
seasideTestsRestCore
	^ self new
		name: 'Seaside-Tests-REST-Core';
		description: 'Unit tests for the package Seaside-REST-Core.';
		addDependency: 'Seaside-REST-Core';
		url: #seasideUrl;
		yourself! !

Object subclass: #WAByMethodRoutesStub
	instanceVariableNames: 'selector arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-REST-Core'!

!WAByMethodRoutesStub methodsFor: 'accessing' stamp: 'pmm 9/9/2009 18:59'!
arguments
	^ arguments! !

!WAByMethodRoutesStub methodsFor: 'stubs' stamp: 'pmm 9/9/2009 19:01'!
compactDatabase: aString
	selector := #compactDatabase:.
	arguments := Array with: aString! !

!WAByMethodRoutesStub methodsFor: 'stubs' stamp: 'pmm 9/9/2009 19:03'!
createBulkDocumentsInDatabase: aString
	selector := #createBulkDocumentsInDatabase:.
	arguments := Array with: aString! !

!WAByMethodRoutesStub methodsFor: 'stubs' stamp: 'pmm 9/9/2009 19:01'!
createDatabase: aString
	selector := #createDatabase:.
	arguments := Array with: aString! !

!WAByMethodRoutesStub methodsFor: 'stubs' stamp: 'pmm 9/9/2009 19:02'!
createNewDocumentInDatabase: aString
	selector := #createNewDocumentInDatabase:.
	arguments := Array with: aString! !

!WAByMethodRoutesStub methodsFor: 'stubs' stamp: 'pmm 9/9/2009 19:55'!
createOrUpdateDocument: aFirstString inDatabase: aSecondString
	selector := #createOrUpdateDocument:inDatabase:.
	arguments := Array with: aFirstString with: aSecondString! !

!WAByMethodRoutesStub methodsFor: 'stubs' stamp: 'pmm 9/9/2009 19:01'!
deleteDatabase: aString
	selector := #deleteDatabase:.
	arguments := Array with: aString! !

!WAByMethodRoutesStub methodsFor: 'stubs' stamp: 'pmm 9/9/2009 19:03'!
deleteDocument: aFirstString inDatabase: aSecondString
	selector := #deleteDocument:inDatabase:.
	arguments := Array with: aFirstString with: aSecondString! !

!WAByMethodRoutesStub methodsFor: 'stubs' stamp: 'pmm 9/9/2009 19:00'!
getAllDatabases
	selector := #getAllDatabases.
	arguments := Array new! !

!WAByMethodRoutesStub methodsFor: 'stubs' stamp: 'pmm 9/9/2009 19:02'!
getAllDocuments: aString
	selector := #getAllDocuments:.
	arguments := Array with: aString! !

!WAByMethodRoutesStub methodsFor: 'stubs' stamp: 'pmm 9/9/2009 19:00'!
getConfig
	selector := #getConfig.
	arguments := Array new! !

!WAByMethodRoutesStub methodsFor: 'stubs' stamp: 'pmm 9/9/2009 19:02'!
getDatabase: aString
	selector := #getDatabase:.
	arguments := Array with: aString! !

!WAByMethodRoutesStub methodsFor: 'stubs' stamp: 'pmm 9/9/2009 19:02'!
getDocument: aFirstString ofDatabase: aSecondString
	selector := #getDocument:ofDatabase:.
	arguments := Array with: aFirstString with: aSecondString! !

!WAByMethodRoutesStub methodsFor: 'stubs' stamp: 'pmm 9/9/2009 19:00'!
getInfo
	selector := #getInfo.
	arguments := Array new! !

!WAByMethodRoutesStub methodsFor: 'stubs' stamp: 'pmm 9/9/2009 19:01'!
getStats
	selector := #getStats.
	arguments := Array new! !

!WAByMethodRoutesStub methodsFor: 'stubs' stamp: 'pmm 9/9/2009 19:01'!
getUuids: aString
	selector := #getUuids:.
	arguments := Array with: aString! !

!WAByMethodRoutesStub methodsFor: 'stubs' stamp: 'pmm 9/9/2009 19:04'!
getView: aFirstString inDesign: aSecondString inDatabase: aThirdString
	selector := #getView:inDesign:inDatabase:.
	arguments := Array with: aFirstString with: aSecondString with: aThirdString! !

!WAByMethodRoutesStub methodsFor: 'stubs' stamp: 'pmm 9/9/2009 19:03'!
queryDatabase: aString
	selector := #queryDatabase:.
	arguments := Array with: aString! !

!WAByMethodRoutesStub methodsFor: 'stubs' stamp: 'pmm 9/9/2009 19:01'!
replicate
	selector := #replicate.
	arguments := Array new! !

!WAByMethodRoutesStub methodsFor: 'accessing' stamp: 'pmm 9/9/2009 18:59'!
selector
	^ selector! !

Object subclass: #WARouteVictimMock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-REST-Core'!

!WARouteVictimMock methodsFor: 'accessing' stamp: 'pmm 9/2/2009 09:31'!
first: anObject
	^ Array with: anObject! !

!WARouteVictimMock methodsFor: 'accessing' stamp: 'pmm 9/2/2009 09:31'!
first: anFirstObject second: aSecondObject
	^ Array with: anFirstObject with: aSecondObject! !

!WARouteVictimMock methodsFor: 'accessing' stamp: 'pmm 9/2/2009 09:31'!
first: anFirstObject second: aSecondObject third: aThirdObject
	^ Array with: anFirstObject with: aSecondObject with: aThirdObject! !

!WARouteVictimMock methodsFor: 'accessing' stamp: 'pmm 9/2/2009 09:34'!
nothing
	^ Array new! !
